"""
__statistics__
"""

#from WMCore.WebTools.Page import TemplatedPage
#from HTTPfetcher import HTTPfetcher
#from types import *
from Table import *
#from time import *
from HTTPfetcher import *
import threading
from TableContents import *


class StatThread(tableThread):
    def __init__ ( self, DASUrl, runid="" ):
      self.table=Statistics(DASUrl,runid)
      threading.Thread.__init__ ( self ) 
########################################################################################################


class Statistics(Table):
  name='stats'
  tableTop="""<table border="0">
<tbody><tr><th colspan="2">%s
       </th>
</tr>"""
  tableRow="""
<tr><td style="background-color: white;">%s</td><td style="background-color: white;"><a href="%s">%s</a></td></tr>"""
  tableFoot="""</tbody></table></div></td>""" 
  tablesData={}
    
  def __init__(self,DASUrl,runid=""):
    self.runid=runid
    self.DASUrl=DASUrl
    self.tables=[expressTable(),expressMergeTable(),repackTable(),repackMergeTable(),recoTable(),recoMergeTable(),alcaTable(),alcaMergeTable()]
    self.threads=[]
    for table in self.tables:
         t=  fetchingThread(DASUrl, table.URL%(str(self.runid)), self.tablesData)
         self.threads.append(t)
         t.start()
         

  def getTableCode(self):
      for t in self.threads:
          t.join()
      statCode="""<table>
  <tr  ><td class="stats" colspan="4"> <b> Statistics:</b> <div id="statslink" align="right"><a href="javascript:loadXMLDoc('stats','stats')" title="Refresh"> <img src="imgs/reload.png"  alt="" style="border: 0px none;" height="16"></a></td>
  </tr><tr>"""
      #print "Tables=="+str(len(tables))+str(tables)
      for table in self.tables:
        #print table.title
        tableCode="""<td class="stats">
                     <div style="float:left;padding-right:10px;"> """   
        tableCode+=self.tableTop %(table.title)
        #print tdata
        
        tdata=self.tablesData[table.URL%(str(self.runid))]
        for i in range(0,len(tdata)):
         try:
           tableCode+=self.tableRow% (str(tdata[i][table.attrStatus]),table.link%(str(self.runid),str(tdata[i][table.attrStatus])),str(tdata[i][table.attrCount]))
         except Exception, e:
          print "Exception: "+str(e)
        tableCode+=self.tableFoot
        statCode+=tableCode
        if self.tables.index(table)%4==3 and self.tables.index(table)+1<len(self.tables) : statCode+="</tr><tr>" 
      statCode+="""</tr></table>"""
      return statCode
        
